
#ifndef _SVD_H
#define _SVD_H

#define SVD_DIM 200

#endif

int svdEispack(float a[][SVD_DIM], int m, int n, 
	       float w[SVD_DIM], float v[][SVD_DIM], float rv1[SVD_DIM]);

/* Sort singular values into decreasing order,
   return permutation array svPerm *... ith sorted
   singular value is then w[svPerm[i]], i in [1, numSamp] (inclusive).
   Note, w[0] is not included in this list. svPerm[0] is undefined. */
void sortSV(int *svPerm, float *w, int numSamp);

int solveLinearSys(float A[][SVD_DIM], float *x, float *b, 
                   int n, float *w);

/* Given svd decomp, A = U w V^T, compute
   inverse of matrix A <- V w^-1 U^T */
void invertMatrix(float A[][SVD_DIM], int n, float w[SVD_DIM], 
                  float U[][SVD_DIM], float V[][SVD_DIM]);

